
registerPerks()
{
	level.MAX_PERKS = 15;

	// register the catch-all before any other perk
	registerInit();

	// make sure we have a lowercase, trimmed order string
	level.ex_specials_order = tolower(extreme\_ex_utils::trim(level.ex_specials_order));

	// build order string if config does not provide one
	if(level.ex_specials_order == "")
	{
		logprint("SPECIALS: Perk ordering string is empty. Rebuilding one!\n");
		level.ex_specials_order = rebuildOrder();
	}

	// do the perk registration based on the order defined in the order string
	perk_array = strtok(level.ex_specials_order, " ");
	if(isDefined(perk_array) && perk_array.size)
	{
		for(i = 0; i < perk_array.size; i++)
		{
			switch(perk_array[i])
			{
				case "-":
					registerPerk(perk_array[i], "ex_specials_na", "black");
					break;
				case "maxhealth":
					if(level.ex_specials_maxhealth)
					{
						registerPerk(perk_array[i], "ex_specials_maxhealth", "spc_health_hudicon");
						registerPerkPrecache(perk_array[i], extreme\_ex_specials_maxhealth::perkInit, extreme\_ex_specials_maxhealth::perkInitPost);
						registerPerkAssignment(perk_array[i], extreme\_ex_specials_maxhealth::perkAssign, extreme\_ex_specials_maxhealth::perkAssignDelayed);
					}
					else registerPerkUnavailable(perk_array[i]);
					break;
				case "maxammo":
					if(level.ex_specials_maxammo)
					{
						registerPerk(perk_array[i], "ex_specials_maxammo", "spc_ammo_hudicon");
						registerPerkPrecache(perk_array[i], extreme\_ex_specials_maxammo::perkInit, extreme\_ex_specials_maxammo::perkInitPost);
						registerPerkAssignment(perk_array[i], extreme\_ex_specials_maxammo::perkAssign, extreme\_ex_specials_maxammo::perkAssignDelayed);
					}
					else registerPerkUnavailable(perk_array[i]);
					break;
				case "vest":
					if(level.ex_vest)
					{
						registerPerk(perk_array[i], "ex_vest", "spc_vest_hudicon");
						registerPerkPrecache(perk_array[i], extreme\_ex_specials_vest::perkInit, extreme\_ex_specials_vest::perkInitPost);
						registerPerkAssignment(perk_array[i], extreme\_ex_specials_vest::perkAssign, extreme\_ex_specials_vest::perkAssignDelayed);
					}
					else registerPerkUnavailable(perk_array[i]);
					break;
				case "beartrap":
					if(level.ex_beartrap)
					{
						registerPerk(perk_array[i], "ex_beartrap", "spc_beartrap_hudicon");
						registerPerkPrecache(perk_array[i], extreme\_ex_specials_beartrap::perkInit, extreme\_ex_specials_beartrap::perkInitPost);
						registerPerkAssignment(perk_array[i], extreme\_ex_specials_beartrap::perkAssign, extreme\_ex_specials_beartrap::perkAssignDelayed);
					}
					else registerPerkUnavailable(perk_array[i]);
					break;
				case "bubble_small":
					if(level.ex_bubble_small)
					{
						registerPerk(perk_array[i], "ex_bubble_small", "spc_bubble_hudicon");
						registerPerkPrecache(perk_array[i], extreme\_ex_specials_bubble_small::perkInit, extreme\_ex_specials_bubble_small::perkInitPost);
						registerPerkAssignment(perk_array[i], extreme\_ex_specials_bubble_small::perkAssign, extreme\_ex_specials_bubble_small::perkAssignDelayed);
					}
					else registerPerkUnavailable(perk_array[i]);
					break;
				case "bubble_big":
					if(level.ex_bubble_big)
					{
						registerPerk(perk_array[i], "ex_bubble_big", "spc_bubble_hudicon");
						registerPerkPrecache(perk_array[i], extreme\_ex_specials_bubble_big::perkInit, extreme\_ex_specials_bubble_big::perkInitPost);
						registerPerkAssignment(perk_array[i], extreme\_ex_specials_bubble_big::perkAssign, extreme\_ex_specials_bubble_big::perkAssignDelayed);
					}
					else registerPerkUnavailable(perk_array[i]);
					break;
				case "stealth":
					if(level.ex_stealth)
					{
						registerPerk(perk_array[i], "ex_stealth", "spc_stealth_hudicon");
						registerPerkPrecache(perk_array[i], extreme\_ex_specials_stealth::perkInit, extreme\_ex_specials_stealth::perkInitPost);
						registerPerkAssignment(perk_array[i], extreme\_ex_specials_stealth::perkAssign, extreme\_ex_specials_stealth::perkAssignDelayed);
					}
					else registerPerkUnavailable(perk_array[i]);
					break;
				case "insertion":
					if(level.ex_insertion)
					{
						registerPerk(perk_array[i], "ex_insertion", "spc_insertion_hudicon");
						registerPerkPrecache(perk_array[i], extreme\_ex_specials_insertion::perkInit, extreme\_ex_specials_insertion::perkInitPost);
						registerPerkAssignment(perk_array[i], extreme\_ex_specials_insertion::perkAssign, extreme\_ex_specials_insertion::perkAssignDelayed);
					}
					else registerPerkUnavailable(perk_array[i]);
					break;
				case "flak":
					if(level.ex_flak)
					{
						registerPerk(perk_array[i], "ex_flak", "spc_flak_hudicon");
						registerPerkPrecache(perk_array[i], extreme\_ex_specials_flak::perkInit, extreme\_ex_specials_flak::perkInitPost);
						registerPerkAssignment(perk_array[i], extreme\_ex_specials_flak::perkAssign, extreme\_ex_specials_flak::perkAssignDelayed);
					}
					else registerPerkUnavailable(perk_array[i]);
					break;
				case "gml":
					if(level.ex_gml)
					{
						registerPerk(perk_array[i], "ex_gml", "spc_gml_hudicon");
						registerPerkPrecache(perk_array[i], extreme\_ex_specials_gml::perkInit, extreme\_ex_specials_gml::perkInitPost);
						registerPerkAssignment(perk_array[i], extreme\_ex_specials_gml::perkAssign, extreme\_ex_specials_gml::perkAssignDelayed);
					}
					else registerPerkUnavailable(perk_array[i]);
					break;
				case "sentrygun":
					if(level.ex_sentrygun)
					{
						registerPerk(perk_array[i], "ex_sentrygun", "spc_sentry_hudicon");
						registerPerkPrecache(perk_array[i], extreme\_ex_specials_sentrygun::perkInit, extreme\_ex_specials_sentrygun::perkInitPost);
						registerPerkAssignment(perk_array[i], extreme\_ex_specials_sentrygun::perkAssign, extreme\_ex_specials_sentrygun::perkAssignDelayed);
					}
					else registerPerkUnavailable(perk_array[i]);
					break;
				case "ugv":
					if(level.ex_ugv)
					{
						registerPerk(perk_array[i], "ex_ugv", "spc_ugv_hudicon");
						registerPerkPrecache(perk_array[i], extreme\_ex_specials_ugv::perkInit, extreme\_ex_specials_ugv::perkInitPost);
						registerPerkAssignment(perk_array[i], extreme\_ex_specials_ugv::perkAssign, extreme\_ex_specials_ugv::perkAssignDelayed);
					}
					else registerPerkUnavailable(perk_array[i]);
					break;
				case "gunship":
					if(level.ex_gunship_special)
					{
						registerPerk(perk_array[i], "ex_gunship_special", "spc_gunship_hudicon");
						registerPerkPrecache(perk_array[i], extreme\_ex_specials_gunship::perkInit, extreme\_ex_specials_gunship::perkInitPost);
						registerPerkAssignment(perk_array[i], extreme\_ex_specials_gunship::perkAssign, extreme\_ex_specials_gunship::perkAssignDelayed);
					}
					else registerPerkUnavailable(perk_array[i]);
					break;
				case "heli":
					if(level.ex_heli)
					{
						registerPerk(perk_array[i], "ex_heli", "spc_heli_hudicon");
						registerPerkPrecache(perk_array[i], extreme\_ex_specials_helicopter::perkInit, extreme\_ex_specials_helicopter::perkInitPost);
						registerPerkAssignment(perk_array[i], extreme\_ex_specials_helicopter::perkAssign, extreme\_ex_specials_helicopter::perkAssignDelayed);
					}
					else registerPerkUnavailable(perk_array[i]);
					break;
				default:
					logprint("SPECIALS: Invalid perk identifier \"" + perk_array[i] + "\". Please check \"ex_specials_order\"!\n");
			}
		}
	}
	else
	{
		level.ex_specials = 0;
		logprint("SPECIALS: Perk ordering string empty or invalid. All perks disabled!\n");
	}

	// Check which perk made it into the array. Turn feature off if not in array
	if(level.ex_specials && game["perkcatalog"].size > 1)
	{
		if(!getPerkIndex("maxhealth")) level.ex_specials_maxhealth = 0;
		if(!getPerkIndex("maxammo")) level.ex_specials_maxammo = 0;
		if(!getPerkIndex("vest")) level.ex_vest = 0;
		if(!getPerkIndex("beartrap")) level.ex_beartrap = 0;
		if(!getPerkIndex("bubble_small")) level.ex_bubble_small = 0;
		if(!getPerkIndex("bubble_big")) level.ex_bubble_big = 0;
		if(!getPerkIndex("stealth")) level.ex_stealth = 0;
		if(!getPerkIndex("insertion")) level.ex_insertion = 0;
		if(!getPerkIndex("flak")) level.ex_flak = 0;
		if(!getPerkIndex("gml")) level.ex_gml = 0;
		if(!getPerkIndex("sentrygun")) level.ex_sentrygun = 0;
		if(!getPerkIndex("ugv")) level.ex_ugv = 0;
		if(!getPerkIndex("gunship")) level.ex_gunship_special = 0;
		if(!getPerkIndex("heli")) level.ex_heli = 0;
	}
	else
	{
		level.ex_specials = 0;
		logprint("SPECIALS: No perks registered. All perks disabled!\n");
	}
}

rebuildOrder()
{
	specials = [];
	if(level.ex_specials_maxhealth && specials.size < level.MAX_PERKS) specials[specials.size] = "maxhealth";
	if(level.ex_specials_maxammo && specials.size < level.MAX_PERKS) specials[specials.size] = "maxammo";
	if(level.ex_vest && specials.size < level.MAX_PERKS) specials[specials.size] = "vest";
	if(level.ex_beartrap && specials.size < level.MAX_PERKS) specials[specials.size] = "beartrap";
	if(level.ex_bubble_small && specials.size < level.MAX_PERKS) specials[specials.size] = "bubble_small";
	if(level.ex_bubble_big && specials.size < level.MAX_PERKS) specials[specials.size] = "bubble_big";
	if(level.ex_stealth && specials.size < level.MAX_PERKS) specials[specials.size] = "stealth";
	if(level.ex_insertion && specials.size < level.MAX_PERKS) specials[specials.size] = "insertion";
	if(level.ex_flak && specials.size < level.MAX_PERKS) specials[specials.size] = "flak";
	if(level.ex_gml && specials.size < level.MAX_PERKS) specials[specials.size] = "gml";
	if(level.ex_sentrygun && specials.size < level.MAX_PERKS) specials[specials.size] = "sentrygun";
	if(level.ex_ugv && specials.size < level.MAX_PERKS) specials[specials.size] = "ugv";
	if(level.ex_gunship_special && specials.size < level.MAX_PERKS) specials[specials.size] = "gunship";
	if(level.ex_heli && specials.size < level.MAX_PERKS) specials[specials.size] = "heli";

	specials_order = "";
	for(i = 0; i < specials.size; i++) specials_order = specials_order + specials[i] + " ";

	return( tolower(extreme\_ex_utils::trim(specials_order)) );
}

init()
{
	if(level.ex_specials) [[level.ex_registerCallback]]("onPlayerConnected", ::onPlayerConnected);
	if(level.ex_specials) [[level.ex_registerCallback]]("onPlayerSpawned", ::onPlayerSpawned);
	if(level.ex_gunship || level.ex_specials) [[level.ex_registerCallback]]("onPlayerKilled", ::onPlayerKilled);
	if(level.ex_gunship || level.ex_specials) [[level.ex_registerCallback]]("onJoinedTeam", ::onJoinedTeam);
	if(level.ex_gunship || level.ex_specials) [[level.ex_registerCallback]]("onJoinedSpectators", ::onJoinedSpectators);

	// check if it makes sense to start monitor for delays
	if(!level.ex_specials) return;
	if(!isDefined(game["perkcatalog"]) || game["perkcatalog"].size == 1) return;

	team_delay = 0;
	for(i = 1; i < game["perkcatalog"].size; i++) team_delay += game["perkcatalog"][i]["team_delay"];
	player_delay = 0;
	for(i = 1; i < game["perkcatalog"].size; i++) team_delay += game["perkcatalog"][i]["player_delay"];
	if(team_delay || player_delay) [[level.ex_registerLevelEvent]]("onSecond", ::onSecond);
}

initPost()
{
	for(i = 1; i < game["perkcatalog"].size; i++)
		if(isDefined(game["perkcatalog"][i]["initpostproc"])) thread [[game["perkcatalog"][i]["initpostproc"]]]();
}

onSecond(eventID)
{
	for(i = 1; i < game["perkcatalog"].size; i++)
	{
		if(game["perkcatalog"][i]["axis_delay"] > 0) game["perkcatalog"][i]["axis_delay"]--;
		if(game["perkcatalog"][i]["allies_delay"] > 0) game["perkcatalog"][i]["allies_delay"]--;
	}

	for(i = 0; i < level.ex_maxclients; i++)
		for(j = 1; j < game["perkcatalog"].size; j++)
			if(game["perks"][i][game["perkcatalog"][j]["name"]]["player_delay"] > 0) game["perks"][i][game["perkcatalog"][j]["name"]]["player_delay"]--;
}

onPlayerConnected()
{
	self playerResetPerks();
}

onPlayerSpawned()
{
	playerUnlockPerks();

	for(i = 1; i < game["perkcatalog"].size; i++)
		if(isDefined(game["perkcatalog"][i]["assigndelayproc"])) thread [[game["perkcatalog"][i]["assigndelayproc"]]](level.ex_specials_testdelay);

	self thread playerGiveBackPerks();
}

onPlayerKilled()
{
	if(level.ex_gunship) level thread extreme\_ex_gunship::gunshipDetachPlayerLevel(self);
	if(level.ex_specials)
	{
		entity = self getEntityNumber();
		if(level.ex_vest) self thread playerStopUsingPerk("vest", true);
		if(level.ex_stealth)
		{
			self thread playerStopUsingPerk("stealth", true);
			if(isDefined(self.ex_stealth))
			{
				self.ex_stealth = undefined;
				if(isDefined(self.pers["savedmodel"])) self maps\mp\_utility::loadModel(self.pers["savedmodel"]);
			}
		}
		if(level.ex_gml && (level.ex_gml_remove & 2) == 2) level thread extreme\_ex_specials_gml::perkRemoveFrom(self);
		if(level.ex_flak && (level.ex_flak_remove & 2) == 2) level thread extreme\_ex_specials_flak::perkRemoveFrom(self);
		if(level.ex_sentrygun && (level.ex_sentrygun_remove & 2) == 2) level thread extreme\_ex_specials_sentrygun::perkRemoveFrom(self);
		if(level.ex_ugv && (level.ex_ugv_remove & 2) == 2) level thread extreme\_ex_specials_ugv::perkRemoveFrom(self);
		if(level.ex_gunship_special)
		{
			self thread playerStopUsingPerk("gunship");
			level thread extreme\_ex_specials_gunship::gunshipSpecialDetachPlayerLevel(self);
		}
	}
}

onPlayerDisconnected(entity)
{
	// called from _ex_clientcontrol::exPlayerDisconnect() to get entity parameter
	if(level.ex_specials)
	{
		if(level.ex_vest) level thread extreme\_ex_specials::levelResetUsingPerk(entity, "vest");
		if(level.ex_gunship_special) level thread extreme\_ex_specials::levelResetUsingPerk(entity, "gunship");
	}
}

onJoinedTeam()
{
	if(level.ex_gunship) level thread extreme\_ex_gunship::gunshipDetachPlayerLevel(self);
	if(level.ex_gunship_special) level thread extreme\_ex_specials_gunship::gunshipSpecialDetachPlayerLevel(self);

	// update specialty store cvars
	self thread extreme\_ex_specials::playerSpecialtyCvars();
}

onJoinedSpectators()
{
	if(level.ex_gunship) level thread extreme\_ex_gunship::gunshipDetachPlayerLevel(self);
	if(level.ex_gunship_special) level thread extreme\_ex_specials_gunship::gunshipSpecialDetachPlayerLevel(self);
}

registerInit()
{
	if(!isDefined(game["perkcatalog"])) game["perkcatalog"] = [];
	// Occupy array index 0 so perk catalog aligns with perk menu numbers
	registerPerk("-", "ex_specials_na", "black");
}

registerPerkUnavailable(perk)
{
	registerPerk("-", "ex_specials_na", "black");
	logprint("SPECIALS: Perk \"" + perk + "\" skipped, because it is not enabled!\n");
}

registerPerk(perk, configid, shader)
{
	if(game["perkcatalog"].size <= level.MAX_PERKS)
	{
		if(perk == "-" || !getPerkIndex(perk))
		{
			index = game["perkcatalog"].size;
			game["perkcatalog"][index]["name"] = perk;
			game["perkcatalog"][index]["axis_delay"] = 0;
			game["perkcatalog"][index]["axis_used"] = 0;
			game["perkcatalog"][index]["allies_delay"] = 0;
			game["perkcatalog"][index]["allies_used"] = 0;
			game["perkcatalog"][index]["shader"] = shader;

			// set default properties
			game["perkcatalog"][index]["stock"] = 999999;
			game["perkcatalog"][index]["price"] = 0;
			game["perkcatalog"][index]["group"] = 0;
			game["perkcatalog"][index]["keep"] = 1;
			game["perkcatalog"][index]["player_maxbuy"] = 0;
			game["perkcatalog"][index]["player_maxact"] = 0;
			game["perkcatalog"][index]["player_delay"] = 0;
			game["perkcatalog"][index]["team_maxbuy"] = 0;
			game["perkcatalog"][index]["team_maxact"] = 0;
			game["perkcatalog"][index]["team_delay"] = 0;
			game["perkcatalog"][index]["test"] = 0;

			// get menu text
			game["perkcatalog"][index]["menutext"] = [[level.ex_drm]](configid + "_text", "[No Text Defined]", "", "", "string");

			// get perk properties
			if(perk != "-")
			{
				[[level.ex_PrecacheShader]](game["perkcatalog"][index]["shader"]);

				// stock, price, group, keep, player_maxbuy, player_maxact, player_delay, team_maxbuy, team_maxact, team_delay, test
				auth = extreme\_ex_utils::trim([[level.ex_drm]](configid + "_auth", "999999,0,0,1,0,0,0,0,0,0,0", "", "", "string"));
				if(auth == "") auth = "999999,0,0,1,0,0,0,0,0,0,0";
				auth_array = strtok(auth, ",");
				if(isDefined(auth_array) && auth_array.size == 11)
				{
					game["perkcatalog"][index]["stock"] = strToInt(auth_array[0], 999999);
					game["perkcatalog"][index]["price"] = strToInt(auth_array[1], 0);
					game["perkcatalog"][index]["group"] = strToInt(auth_array[2], 0);
					game["perkcatalog"][index]["keep"] = strToInt(auth_array[3], 1);
					game["perkcatalog"][index]["player_maxbuy"] = strToInt(auth_array[4], 0);
					game["perkcatalog"][index]["player_maxact"] = strToInt(auth_array[5], 0);
					game["perkcatalog"][index]["player_delay"] = strToInt(auth_array[6], 0);
					game["perkcatalog"][index]["team_maxbuy"] = strToInt(auth_array[7], 0);
					game["perkcatalog"][index]["team_maxact"] = strToInt(auth_array[8], 0);
					game["perkcatalog"][index]["team_delay"] = strToInt(auth_array[9], 0);
					game["perkcatalog"][index]["test"] = strToInt(auth_array[10], 0);
					/*
					logprint("SPECIALS: setting properties for perk \"" + perk + "\" to...\n");
					logprint("        stock: " + game["perkcatalog"][index]["stock"] + "\n");
					logprint("        price: " + game["perkcatalog"][index]["price"] + "\n");
					logprint("        group: " + game["perkcatalog"][index]["group"] + "\n");
					logprint("         keep: " + game["perkcatalog"][index]["keep"] + "\n");
					logprint("player_maxbuy: " + game["perkcatalog"][index]["player_maxbuy"] + "\n");
					logprint("player_maxact: " + game["perkcatalog"][index]["player_maxact"] + "\n");
					logprint(" player_delay: " + game["perkcatalog"][index]["player_delay"] + "\n");
					logprint("  team_maxbuy: " + game["perkcatalog"][index]["team_maxbuy"] + "\n");
					logprint("  team_maxact: " + game["perkcatalog"][index]["team_maxact"] + "\n");
					logprint("   team_delay: " + game["perkcatalog"][index]["team_delay"] + "\n");
					logprint("         test: " + game["perkcatalog"][index]["test"] + "\n");
					*/
				}
				else logprint("SPECIALS: setting default properties for perk \"" + perk + "\"\n");
			}

			// make sure we have the perks tracking array
			if(!isDefined(game["perks"]))
			{
				game["perks"] = [];
				for(i = 0; i < level.ex_maxclients; i++) game["perks"][i] = [];
			}

			// populate tracking array for this perk, but do not process "-" more than once
			if(perk != "-" || !isDefined(game["perks"][0][perk]))
			{
				if(perk == "-") logprint("SPECIALS: Catch-all \"" + perk + "\" registered on index " + index + "\n");
					else logprint("SPECIALS: Perk \"" + perk + "\" registered on index " + index + "\n");

				for(i = 0; i < level.ex_maxclients; i++)
				{
					game["perks"][i][perk]["bought"] = 0;
					game["perks"][i][perk]["used"] = 0;
					game["perks"][i][perk]["active"] = 0;
					game["perks"][i][perk]["locked"] = false;
					game["perks"][i][perk]["player_delay"] = 0;
				}
			}
			else logprint("SPECIALS: Empty slot \"" + perk + "\" registered on index " + index + "\n");
		}
		else logprint("SPECIALS: Perk \"" + perk + "\" already registered!\n");
	}
	else logprint("SPECIALS: Perk \"" + perk + "\" discarded. Maximum number of perks registered!\n");
}

registerPerkPrecache(perk, initproc, initpostproc)
{
	index = getPerkIndex(perk);
	if(index)
	{
		// execute perk precaching now
		if(isDefined(initproc)) thread [[initproc]]();

		// store post-map precaching procedure for later use by initPost()
		game["perkcatalog"][index]["initpostproc"] = initpostproc;
	}
}

registerPerkAssignment(perk, assignproc, assigndelayproc)
{
	index = getPerkIndex(perk);
	if(index)
	{
		// store assignment procedure for later use
		game["perkcatalog"][index]["assignproc"] = assignproc;

		// store delayed assignment procedure for later use by onPlayerSpawned()
		if(game["perkcatalog"][index]["test"]) game["perkcatalog"][index]["assigndelayproc"] = assigndelayproc;
	}
}

getPerkIndex(perk)
{
	for(i = 1; i < game["perkcatalog"].size; i++)
		if(game["perkcatalog"][i]["name"] == perk) return(i);
	return(0);
}

getPerkPriority(perk)
{
	// priority based on registration order
	index = getPerkIndex(perk);
	if(!index) return(false);
	entity = self getEntityNumber();
	for(i = index + 1; i < game["perkcatalog"].size; i++)
	{
		perk = game["perkcatalog"][i]["name"];
		if(perk == "-") continue;
		if(game["perks"][entity][perk]["locked"] && (game["perks"][entity][perk]["used"] < game["perks"][entity][perk]["bought"])) return(false);
	}
	return(true);
}

playerResetPerks()
{
	entity = self getEntityNumber();
	for(i = 1; i < game["perkcatalog"].size; i++)
	{
		if(game["perkcatalog"][i]["name"] == "-") continue;
		game["perks"][entity][game["perkcatalog"][i]["name"]]["bought"] = 0;
		game["perks"][entity][game["perkcatalog"][i]["name"]]["used"] = 0;
		game["perks"][entity][game["perkcatalog"][i]["name"]]["active"] = 0;
		game["perks"][entity][game["perkcatalog"][i]["name"]]["locked"] = false;
		game["perks"][entity][game["perkcatalog"][i]["name"]]["player_delay"] = 0;
	}
}

playerUnlockPerks()
{
	entity = self getEntityNumber();
	for(i = 1; i < game["perkcatalog"].size; i++)
	{
		if(game["perkcatalog"][i]["name"] == "-" || game["perkcatalog"][i]["name"] == "insertion") continue;
		game["perks"][entity][game["perkcatalog"][i]["name"]]["locked"] = false;
	}
}

playerPerkIsLocked(perk, lock)
{
	if(!isDefined(lock)) lock = false;
	entity = self getEntityNumber();
	locked = game["perks"][entity][perk]["locked"];
	if(!locked && lock) game["perks"][entity][perk]["locked"] = true;
	return(locked);
}

playerBoughtPerk(perk)
{
	entity = self getEntityNumber();
	game["perks"][entity][perk]["bought"]++;
	game["perks"][entity][perk]["locked"] = true;

	//logprint("DEBUG: player " + self.name + " bought perk \"" + perk + "\" (total " + game["perks"][entity][perk]["bought"] + ")\n");
}

playerStartUsingPerk(perk, unlock)
{
	if(!isDefined(unlock)) unlock = false;
	entity = self getEntityNumber();
	game["perks"][entity][perk]["used"]++;
	game["perks"][entity][perk]["active"]++;
	if(unlock) game["perks"][entity][perk]["locked"] = false;

	if(level.ex_teamplay)
	{
		index = getPerkIndex(perk);
		if(self.pers["team"] == "axis") game["perkcatalog"][index]["axis_used"]++;
			else game["perkcatalog"][index]["allies_used"]++;

		// set team delay
		if(self.pers["team"] == "axis") game["perkcatalog"][index]["axis_delay"] = game["perkcatalog"][index]["team_delay"];
			else game["perkcatalog"][index]["allies_delay"] = game["perkcatalog"][index]["team_delay"];
	}

	//logprint("DEBUG: player " + self.name + " started using perk \"" + perk + "\" (total " + game["perks"][entity][perk]["active"] + ")\n");
}

playerStopUsingPerk(perk, unlock)
{
	if(!isDefined(unlock)) unlock = false;
	entity = self getEntityNumber();
	if(game["perks"][entity][perk]["active"])
	{
		game["perks"][entity][perk]["active"]--;
		if(unlock) game["perks"][entity][perk]["locked"] = false;

		// set player delay
		index = getPerkIndex(perk);
		game["perks"][entity][perk]["player_delay"] = game["perkcatalog"][index]["player_delay"];

		//logprint("DEBUG: player " + self.name + " stopped using perk \"" + perk + "\" (total " + game["perks"][entity][perk]["active"] + ")\n");
	}
}

levelStopUsingPerk(entity, perk, unlock)
{
	if(!isDefined(unlock)) unlock = false;
	if(game["perks"][entity][perk]["active"])
	{
		game["perks"][entity][perk]["active"]--;
		if(unlock) game["perks"][entity][perk]["locked"] = false;

		// set player delay
		index = getPerkIndex(perk);
		game["perks"][entity][perk]["player_delay"] = game["perkcatalog"][index]["player_delay"];

		//logprint("DEBUG: level stopped using perk \"" + perk + "\" for entity " + entity + " (total " + game["perks"][entity][perk]["active"] + ")\n");
	}
}

levelResetUsingPerk(entity, perk)
{
	game["perks"][entity][perk]["active"] = 0;
	//logprint("DEBUG: level reset of perk \"" + perk + "\" for entity " + entity + " (total " + game["perks"][entity][perk]["active"] + ")\n");
}

playerGiveBackPerks(entity)
{
	entity = self getEntityNumber();
	for(i = 1; i < game["perkcatalog"].size; i++)
	{
		perk = game["perkcatalog"][i]["name"];
		if(perk == "-") continue;
		if(game["perkcatalog"][i]["keep"] && isDefined(game["perkcatalog"][i]["assignproc"]))
		{
			bought = game["perks"][entity][perk]["bought"];
			used = game["perks"][entity][perk]["used"];
			if(used < bought) thread [[game["perkcatalog"][i]["assignproc"]]](0);
		}
	}
}

quickrequests(response)
{
	self endon("disconnect");

	if(!isDefined(response)) return;

	if(!level.ex_specials || level.ex_entities_defcon == 2)
	{
		self iprintlnbold(&"SPECIALS_NO_STORE");
		return;
	}

	if(isDefined(self.specials_locked))
	{
		specials_locked_sec = ( (gettime() / 1000) - self.specials_locked);
		if(specials_locked_sec < 300)
		{
			self iprintlnbold(&"SPECIALS_NO_STORE_LOCK");
			return;
		}
		else specials_locked_sec = undefined;
	}

	if(level.ex_specials_minpoints && self.score < level.ex_specials_minpoints)
	{
		self iprintlnbold(&"SPECIALS_NO_STORE_YET", level.ex_specials_minpoints);
		return;
	}

	// Perks
	perk = checkResponse(response);
	if(perk == "-")
	{
		self iprintlnbold(&"SPECIALS_NO_VALIDRESPONSE");
		return;
	}

	if(!checkPerk(perk)) return;

	self thread playerBoughtPerk(perk);
	index = getPerkIndex(perk);
	thread [[game["perkcatalog"][index]["assignproc"]]](0);
}

checkResponse(response)
{
	if(response != "")
	{
		validchars = "-123456789abcdef";
		for(i = 0; i < validchars.size; i++)
		{
			if(response == validchars[i])
			{
				if(isDefined(game["perkcatalog"][i])) return(game["perkcatalog"][i]["name"]);
					else break;
			}
		}
	}
	return(game["perkcatalog"][0]["name"]);
}

checkPerk(perk)
{
	index = getPerkIndex(perk);

	// check if the perk has a valid assignment procedure
	if(index && !isDefined(game["perkcatalog"][index]["assignproc"])) index = 0;

	// can only have one perk gunship or heli, so check if they are available
	if(index)
	{
		if(perk == "gunship" && isPlayer(level.gunship_special.owner)) index = 0;
			else if(perk == "heli" && isDefined(level.helicopter_player)) index = 0;
	}

	// no stealth if you are in the gunship
	if(index && perk == "stealth")
	{
		if( (level.ex_gunship && isPlayer(level.gunship.owner) && level.gunship.owner == self) ||
		    (level.ex_gunship_special && isPlayer(level.gunship_special.owner) && level.gunship_special.owner == self) ) index = 0;
	}

	// no vest if you are in stealth mode and vice versa
	if(index && perk == "vest" && playerPerkIsLocked("stealth", false)) index = 0;
	if(index && perk == "stealth" && playerPerkIsLocked("vest", false)) index = 0;

	// check if feature is available
	if(!index)
	{
		self iprintlnbold(&"SPECIALS_NO_FEATURE");
		return(false);
	}

	// check if perk is in stock
	if(!game["perkcatalog"][index]["stock"])
	{
		self iprintlnbold(&"SPECIALS_NO_STOCK");
		return(false);
	}

	// check if perk is already available to player
	entity = self getEntityNumber();
	available = !game["perks"][entity][perk]["locked"];
	if(perk == "maxhealth") available = (self.health < 100);
	if(level.ex_currentgt == "ft" && isDefined(self.frozenstate) && self.frozenstate == "frozen") available = false;
	if(!available)
	{
		self iprintlnbold(&"SPECIALS_NO_PERK");
		return(false);
	}

	// check player delay
	player_delay = game["perks"][entity][perk]["player_delay"];
	if(player_delay)
	{
		self iprintlnbold(&"SPECIALS_NO_PLAYERDELAY", player_delay);
		return(false);
	}

	// check team delay
	if(level.ex_teamplay)
	{
		if(self.pers["team"] == "axis") team_delay = game["perkcatalog"][index]["axis_delay"];
			else team_delay = game["perkcatalog"][index]["allies_delay"];
		if(team_delay)
		{
			self iprintlnbold(&"SPECIALS_NO_TEAMDELAY", team_delay);
			return(false);
		}
	}

	// check player max buy
	limit = game["perkcatalog"][index]["player_maxbuy"];
	if(limit)
	{
		// alternatively have it check for limit on bought perks
		//if(game["perks"][entity][perk]["bought"] >= limit)
		if(game["perks"][entity][perk]["used"] >= limit)
		{
			self iprintlnbold(&"SPECIALS_NO_MAXBUY", limit);
			return(false);
		}
	}

	// check player max active
	limit = game["perkcatalog"][index]["player_maxact"];
	if(limit)
	{
		if(game["perks"][entity][perk]["active"] >= limit)
		{
			self iprintlnbold(&"SPECIALS_NO_MAXACT", limit);
			return(false);
		}
	}

	// check team max buy
	if(level.ex_teamplay)
	{
		limit = game["perkcatalog"][index]["team_maxbuy"];
		if(limit)
		{
			if(self.pers["team"] == "axis") bought = game["perkcatalog"][index]["axis_used"];
				else bought = game["perkcatalog"][index]["allies_used"];
			if(bought >= limit)
			{
				self iprintlnbold(&"SPECIALS_NO_MAXBUY_TEAM", limit);
				return(false);
			}
		}

		// check team max active
		limit = game["perkcatalog"][index]["team_maxact"];
		if(limit)
		{
			if(getTeamActive(perk) >= limit)
			{
				self iprintlnbold(&"SPECIALS_NO_MAXACT_TEAM", limit);
				return(false);
			}
		}

		// check group max active for team
		group = game["perkcatalog"][index]["group"];
		if(group)
		{
			if(getTeamGroupActive(perk, group) > 0)
			{
				self iprintlnbold(&"SPECIALS_NO_MAXGROUP", group);
				return(false);
			}
		}
	}
	else
	{
		// check group max active for player
		group = game["perkcatalog"][index]["group"];
		if(group)
		{
			if(getPlayerGroupActive(perk, group) > 0)
			{
				self iprintlnbold(&"SPECIALS_NO_MAXGROUP", group);
				return(false);
			}
		}
	}

	// check price (keep last because it handles payment)
	price = game["perkcatalog"][index]["price"];
	if(self.score < 0)
	{
		self iprintlnbold(&"SPECIALS_NO_POINTS_SUBZERO");
		return(false);
	}
	else if(self.score < price)
	{
		self iprintlnbold(&"SPECIALS_NO_POINTS", price);
		return(false);
	}

	// keep price check last, because it handles payment (score adjustment)
	if(price > 0)
	{
		// keep specials_cash above adjusting score, otherwise it will force a rank demotion
		self.pers["specials_cash"] = self.pers["specials_cash"] + price;
		self.score = self.score - price;
		if(isDefined(self.pers["score"])) self.pers["score"] = self.score;

		// if using the arcade hud points, adjust the score for it
		if(level.ex_arcade) self thread extreme\_ex_arcade::checkScoreUpdate();
	}

	// adjust stock
	game["perkcatalog"][index]["stock"]--;

	return(true);
}

getPlayerGroupActive(perk, group)
{
	total = 0;
	entity = self getEntityNumber();
	for(i = 1; i < game["perkcatalog"].size; i++)
	{
		if(game["perkcatalog"][i]["group"] == group)
		{
			other_perk = game["perkcatalog"][i]["name"];
			if(perk != other_perk) total += game["perks"][entity][other_perk]["active"];
		}
	}
	return(total);
}

getTeamGroupActive(perk, group)
{
	total = 0;
	players = level.players;
	for(i = 0; i < players.size; i++)
	{
		player = players[i];
		if(!isDefined(player.pers["team"])) continue;
		if(player.pers["team"] == self.pers["team"]) total += player getPlayerGroupActive(perk, group);
	}
	return(total);
}

getTeamActive(perk)
{
	total = 0;
	players = level.players;
	for(i = 0; i < players.size; i++)
	{
		player = players[i];
		if(!isDefined(player.pers["team"])) continue;
		if(player.pers["team"] == self.pers["team"])
		{
			entity = player getEntityNumber();
			total += game["perks"][entity][perk]["active"];
		}
	}
	return(total);
}

playerSpecialtyCvars()
{
	if(level.ex_specials)
	{
		for(i = 1; i <= level.MAX_PERKS; i++)
		{
			if(isDefined(game["perkcatalog"][i]))
				self setClientCvar("ui_specials_perk" + i, getSpecialtyKey(i) + game["perkcatalog"][i]["menutext"]);
			else
				self setClientCvar("ui_specials_perk" + i, getSpecialtyKey(i) + game["perkcatalog"][0]["menutext"]);
		}
	}
}

getSpecialtyKey(index)
{
	switch(index)
	{
		case  1: return("1. ");
		case  2: return("2. ");
		case  3: return("3. ");
		case  4: return("4. ");
		case  5: return("5. ");
		case  6: return("6. ");
		case  7: return("7. ");
		case  8: return("8. ");
		case  9: return("9. ");
		case 10: return("A. ");
		case 11: return("B. ");
		case 12: return("C. ");
		case 13: return("D. ");
		case 14: return("E. ");
		case 15: return("F. ");
	}
}

hudNotifySpecial(perk)
{
	self endon("kill_thread");

	shader = "black";
	index = getPerkIndex(perk);
	shader = game["perkcatalog"][index]["shader"];

	// first check if this hud elem is already on screen
	hudelem = "spc_icon" + index;
	if(!isDefined(self.pers[hudelem]))
	{
		// move other perk hud elems to the right
		for(i = 1; i < game["perkcatalog"].size; i++)
		{
			checkelem = "spc_icon" + i;
			if(isDefined(self.pers[checkelem]))
			{
				self.pers[checkelem] moveOverTime(.25);
				self.pers[checkelem].x = self.pers[checkelem].x + 30;
			}
		}

		self.pers[hudelem] = newClientHudElem(self);
		self.pers[hudelem].archived = true;
		self.pers[hudelem].horzAlign = "fullscreen";
		self.pers[hudelem].vertAlign = "fullscreen";
		self.pers[hudelem].alignx = "center";
		self.pers[hudelem].aligny = "middle";
		self.pers[hudelem].x = 120;
		self.pers[hudelem].y = 450;
		self.pers[hudelem].alpha = level.ex_iconalpha;
		self.pers[hudelem] setShader(shader, 32, 32);
		self.pers[hudelem] scaleOverTime(.5, 24, 24);
	}
}

hudNotifySpecialRemove(perk, delay)
{
	self endon("kill_thread");

	if(isDefined(delay)) wait( [[level.ex_fpstime]](delay) );

	index = getPerkIndex(perk);
	hudelem = "spc_icon" + index;
	if(isDefined(self.pers[hudelem]))
	{
		hudelem_x = self.pers[hudelem].x;
		self.pers[hudelem] destroy();

		for(i = 1; i < game["perkcatalog"].size; i++)
		{
			hudelem = "spc_icon" + i;
			if(isDefined(self.pers[hudelem]) && self.pers[hudelem].x > hudelem_x)
			{
				self.pers[hudelem] moveOverTime(.25);
				self.pers[hudelem].x = self.pers[hudelem].x - 30;
			}
		}
	}
}

hudNotifyProtected()
{
	if(!isDefined(self.ex_spc_proticon))
	{
		self.ex_spc_proticon = newClientHudElem(self);
		self.ex_spc_proticon.archived = true;
		self.ex_spc_proticon.horzAlign = "fullscreen";
		self.ex_spc_proticon.vertAlign = "fullscreen";
		self.ex_spc_proticon.alignx = "center";
		self.ex_spc_proticon.aligny = "middle";
		self.ex_spc_proticon.x = 150;
		self.ex_spc_proticon.y = 420;
		self.ex_spc_proticon.alpha = level.ex_iconalpha;
		self.ex_spc_proticon setShader(game["mod_protect_hudicon"], 24, 24);
	}
}

hudNotifyProtectedRemove()
{
	if(isDefined(self.ex_spc_proticon)) self.ex_spc_proticon destroy();
}

hudNotifyTestFlash(color)
{
	level endon("ex_gameover");
	self endon("disconnect");

	hudNotifyTestFlashRemove();

	self.ex_test_icon = newClientHudElem(self);
	self.ex_test_icon.archived = false;
	self.ex_test_icon.horzAlign = "fullscreen";
	self.ex_test_icon.vertAlign = "fullscreen";
	self.ex_test_icon.alignx = "center";
	self.ex_test_icon.aligny = "middle";
	self.ex_test_icon.x = 320;
	self.ex_test_icon.y = 140;
	self.ex_test_icon.color = color;
	self.ex_test_icon.alpha = 1;
	self.ex_test_icon setShader("white", 24, 24);

	wait( [[level.ex_fpstime]](1) );
	hudNotifyTestFlashRemove();
}

hudNotifyTestFlashRemove()
{
	if(isDefined(self.ex_test_icon)) self.ex_test_icon destroy();
}

strToInt(str, defint)
{
	if(!isDefined(str) || str == "") return(defint);

	validchars = "-+0123456789";
	for(i = 0; i < str.size; i++)
		if(!issubstr(validchars, str[i])) return(defint);

	return(int(str));
}
