#include extreme\_ex_specials;

perkInit()
{
	// perk related precaching
	level.bubbles = [];
	[[level.ex_PrecacheModel]]("xmodel/huaf_bubble_big");

	[[level.ex_PrecacheShader]]("x2_bubbleunlock");
	game["mod_protect_hudicon"] = "mod_protect_hudicon";
	[[level.ex_PrecacheShader]](game["mod_protect_hudicon"]);

	level.ex_effect["bubble_burst_big"] = [[level.ex_PrecacheEffect]]("fx/bubble/bubble_burst_big.efx");
}

perkInitPost()
{
	// perk related precaching after map load
}

perkAssignDelayed(delay)
{
	self endon("kill_thread");

	if(isDefined(self.pers["isbot"])) return;
	wait( [[level.ex_fpstime]](delay) );

	if(!playerPerkIsLocked("bubble_big", true)) self thread perkAssign(0);
}

perkAssign(delay)
{
	self endon("kill_thread");

	wait( [[level.ex_fpstime]](delay) );

	if(level.ex_arcade_shaders) self thread extreme\_ex_arcade::showArcadeShader("x2_bubbleunlock", level.ex_arcade_shaders_perk);
		else self iprintlnbold(&"SPECIALS_BUBBLE_READY");

	self hudNotifySpecial("bubble_big");

	while(true)
	{
		wait( [[level.ex_fpstime]](.05) );
		if(!self isOnGround()) continue;
		if(self meleebuttonpressed())
		{
			count = 0;
			while(self meleeButtonPressed() && count < 10)
			{
				wait( [[level.ex_fpstime]](.05) );
				count++;
			}
			if(count >= 10)
			{
				if(getPerkPriority("bubble_big"))
				{
					if(!extreme\_ex_utils::tooClose(level.ex_mindist["perks"][0], level.ex_mindist["perks"][1], level.ex_mindist["perks"][2], level.ex_mindist["perks"][3])) break;
				}
				while(self meleebuttonpressed()) wait( [[level.ex_fpstime]](.05) );
			}
		}
	}

	self thread playerStartUsingPerk("bubble_big", true);
	self hudNotifySpecialRemove("bubble_big");

	angles = (0, self.angles[1], 0);
	origin = self.origin;

	level thread bubbleCreate(self, origin, angles);
}

bubbleCreate(owner, origin, angles)
{
	index = bubbleAllocate();

	level.bubbles[index].origin = origin;
	level.bubbles[index].angles = angles;

	level.bubbles[index].timer = level.ex_bubble_big_timer * 20;
	level.bubbles[index].bubble = spawn("script_model", origin);
	level.bubbles[index].bubble hide();
	level.bubbles[index].bubble setmodel("xmodel/huaf_bubble_big");
	level.bubbles[index].bubble.angles = angles;
	level.bubbles[index].bubble_trig = spawn("trigger_radius", origin, 0, 88, 88);

	// set owner last so other code knowns it's fully initialized
	level.bubbles[index].ownernum = owner getEntityNumber();
	level.bubbles[index].team = owner.pers["team"];
	level.bubbles[index].bubble playsound("bubble_create");
	level.bubbles[index].bubble show();
	level.bubbles[index].owner = owner;

	level thread bubbleThink(index);
}

bubbleAllocate()
{
	for(i = 0; i < level.bubbles.size; i++)
	{
		if(level.bubbles[i].inuse == 0)
		{
			level.bubbles[i].inuse = 1;
			return(i);
		}
	}

	level.bubbles[i] = spawnstruct();
	level.bubbles[i].inuse = 1;
	return(i);
}

bubbleRemoveFrom(player)
{
	for(i = 0; i < level.bubbles.size; i++)
		if(level.bubbles[i].inuse && isDefined(level.bubbles[i].owner) && level.bubbles[i].owner == player) thread bubbleRemove(i);
}

bubbleRemove(index)
{
	level.bubbles[index].bubble stoploopsound();
	level.bubbles[index].bubble notify("bubble_kill");
	level.bubbles[index].bubble playsound("bubble_destroy");
	level.bubbles[index].bubble rotateyaw(-360, 3, 0, 2);
	wait( [[level.ex_fpstime]](3) );

	players = level.players;
	for(i = 0; i < players.size; i++)
	{
		player = players[i];
		if(isPlayer(player) && isDefined(player.ex_bubble_protected) && player.ex_bubble_protected == index)
		{
			player.ex_bubble_protected = undefined;
			player thread hudNotifyProtectedRemove();
		}
	}

	playfx(level.ex_effect["bubble_burst_big"], level.bubbles[index].bubble.origin);
	bubbleFree(index);
}

bubbleFree(index)
{
	if(isDefined(level.bubbles) && isDefined(level.bubbles[index]))
	{
		thread levelStopUsingPerk(level.bubbles[index].ownernum, "bubble_big");
		level.bubbles[index].owner = undefined;
		if(isDefined(level.bubbles[index].bubble_trig)) level.bubbles[index].bubble_trig delete();
		if(isDefined(level.bubbles[index].bubble)) level.bubbles[index].bubble delete();
		level.bubbles[index].inuse = 0;
	}
}

bubbleThink(index)
{
	level.bubbles[index].bubble playloopsound("bubble_loop");
	level.bubbles[index].bubble thread bubbleRotate(index, 3);

	for(;;)
	{
		// remove bubble if it reached end of life
		if(level.bubbles[index].timer <= 0) break;

		// remove bubble if owner left on DM-style games
		if(!level.ex_teamplay && !isPlayer(level.bubbles[index].owner)) break;

		// check players
		players = level.players;
		for(i = 0; i < players.size; i++)
		{
			player = players[i];
			if(isAlive(player) && player isTouching(level.bubbles[index].bubble_trig) && ((!level.ex_teamplay && player == level.bubbles[index].owner) || (level.ex_teamplay && player.pers["team"] == level.bubbles[index].team)) )
			{
				if(player.health < 100) player.health += 1;
				player.ex_bubble_protected = index;
				player thread hudNotifyProtected();
			}
			else if(isDefined(player.ex_bubble_protected) && player.ex_bubble_protected == index)
			{
				player.ex_bubble_protected = undefined;
				player thread hudNotifyProtectedRemove();
			}
		}

		level.bubbles[index].timer--;
		wait( [[level.ex_fpstime]](.05) );
	}

	bubbleRemove(index);
}

bubbleRotate(index, time)
{
	self endon("bubble_kill");

	while(1)
	{
		self rotateyaw(-360, time);
		wait( [[level.ex_fpstime]](time) );
	}
}
