// extreme\_ex_spawn::spawnSpectator();
// -----------------------------------------------------------------------------
// SD, LMS and LTS move players to spec
// RBCNQ and RBCTF will move players to spec after spawnlimit
// ex_redirect
// ex_readyup
// ex_inactivity
// ex_cmdmonitor
// ex_statsboard
// ex_mapvote
// ex_main::exEndMap

readStats()
{
	self.pers["total_points"] = 0;
	memory = self extreme\_ex_memory::getMemory("total", "points");
	if(!memory.error) self.pers["total_points"] = memory.value;
	if(self.pers["score"]) self.pers["total_points"] -= self.pers["score"];

	self.pers["total_kill"] = 0;
	memory = self extreme\_ex_memory::getMemory("total", "kills");
	if(!memory.error) self.pers["total_kill"] = memory.value;
	if(self.pers["kill"]) self.pers["total_kill"] -= self.pers["kill"];

	self.pers["total_death"] = 0;
	memory = self extreme\_ex_memory::getMemory("total", "deaths");
	if(!memory.error) self.pers["total_death"] = memory.value;
	if(self.pers["death"]) self.pers["total_death"] -= self.pers["death"];

	self.pers["total_bonus"] = 0;
	memory = self extreme\_ex_memory::getMemory("total", "bonus");
	if(!memory.error) self.pers["total_bonus"] = memory.value;
	if(self.pers["bonus"]) self.pers["total_bonus"] -= self.pers["bonus"];

	self.pers["total_special"] = 0;
	memory = self extreme\_ex_memory::getMemory("total", "special");
	if(!memory.error) self.pers["total_special"] = memory.value;
	if(self.pers["special"]) self.pers["total_special"] -= self.pers["special"];

	self.pers["total_time"] = 0;
	memory = self extreme\_ex_memory::getMemory("total", "time");
	if(!memory.error) self.pers["total_time"] = memory.value;

	if(!isDefined(self.pers["total_play"])) self.pers["total_play"] = 0;
	self.pers["total_start"] = 0;
}

writeStats(commit)
{
	// players who are redirected to download don't have these vars yet
	if(!isDefined(self.pers) || !isDefined(self.pers["total_start"])) return;

	// players who made it into intermission already have their stats updated
	if(isDefined(self.pers["total_updated"])) return;
	self.pers["total_updated"] = true;

	self stopPlaying();

	if(isDefined(self.score)) self.pers["total_points"] += self.score;
	self extreme\_ex_memory::setMemory("total", "points", self.pers["total_points"], true);

	if(isDefined(self.pers["kill"])) self.pers["total_kill"] += self.pers["kill"];
	self extreme\_ex_memory::setMemory("total", "kills", self.pers["total_kill"], true);

	if(isDefined(self.deaths)) self.pers["total_death"] += self.deaths;
	self extreme\_ex_memory::setMemory("total", "deaths", self.pers["total_death"], true);

	if(isDefined(self.pers["bonus"])) self.pers["total_bonus"] += self.pers["bonus"];
	self extreme\_ex_memory::setMemory("total", "bonus", self.pers["total_bonus"], true);

	if(isDefined(self.pers["special"])) self.pers["total_special"] += self.pers["special"];
	self extreme\_ex_memory::setMemory("total", "special", self.pers["total_special"], true);

	// update total playing time in minutes
	if(isDefined(self.pers["total_play"])) minutes_play = int( (self.pers["total_play"] + 30) / 60);
		else minutes_play = 0;
	self.pers["total_time"] += minutes_play;
	self extreme\_ex_memory::setMemory("total", "time", self.pers["total_time"], commit);

	if(level.ex_statstotal_log) level thread printStats(self, minutes_play, self.pers["total_time"]);
}

printStats(player, minutes_play, minutes_total)
{
	player_name = player.name;

	info = getDuration(minutes_play);
	minutes_check = (info.years * 365 * 24 * 60) + (info.days * 24 * 60) + (info.hours * 60) + info.minutes;
	if(minutes_play != minutes_check) logprint("TOTALSTATS: " + player_name + " session IN (" + minutes_play + ") does not match session OUT (" + minutes_check + ")\n");
	logprint(player_name + " session (" + minutes_play + "): " + info.message);

	info = getDuration(minutes_total);
	logprint(player_name + " commit (" + minutes_total + "): " + info.message);

	kills_min = getKillsPerMinute(player);
	score_min = getScorePerMinute(player);
	logprint(player_name + " has " + score_min + " score/min, " + kills_min + " kills/min\n");
}

startPlaying()
{
	self.pers["total_start"] = (gettime() / 1000);
	if(level.ex_statstotal_log)
	{
		if(self.pers["total_play"]) logprint(self.name + " resuming session on mark " + self.pers["total_start"] + ", currently " + self.pers["total_play"] + " seconds\n");
			else logprint(self.name + " starting session on mark " + self.pers["total_start"] + "\n");
	}
}

stopPlaying()
{
	if(self.pers["total_start"])
	{
		session_stop = (gettime() / 1000);
		self.pers["total_play"] += (session_stop - self.pers["total_start"]);
		if(level.ex_statstotal_log) logprint(self.name + " stopping session on mark " + session_stop + ", currently " + self.pers["total_play"] + " seconds\n");
		self.pers["total_start"] = 0;
	}
}

getMyKillsPerMinute()
{
	return( getKillsPerMinute(self) );
}

getKillsPerMinute(player)
{
	if(!isPlayer(player) || player.pers["total_time"] < level.ex_statstotal_balance_skill) return(0);
	player_skill = player.pers["total_kill"] / player.pers["total_time"];
	if(player_skill < 1) return(0);
	return( player_skill );
}

getMyScorePerMinute()
{
	return( getScorePerMinute(self) );
}

getScorePerMinute(player)
{
	if(!isPlayer(player) || player.pers["total_time"] < level.ex_statstotal_balance_skill) return(0);
	player_skill = player.pers["total_points"] / player.pers["total_time"];
	if(player_skill < 1) return(0);
	return( player_skill );
}

getMySkillLevel()
{
	if(level.ex_statstotal_balance == 1) return( getScorePerMinute(self) );
		else return( getKillsPerMinute(self) );
}

getTeamSkillLevel(team)
{
	team_players = 0;
	team_total = 0;

	players = level.players;
	for(i = 0; i < players.size; i++)
	{
		player = players[i];
		if(!isPlayer(player)) continue;
		if(isDefined(player.pers["team"]) && player.pers["team"] == team)
		{
			player_skill = player getMySkillLevel();
			if(player_skill != 0)
			{
				team_players++;
				team_total += player_skill;
			}
		}
	}
	if(!team_total || !team_players) return(0);
		else return( team_total / team_players );
}

getDuration(minutes)
{
	minutes_hour = 60;
	minutes_day = minutes_hour * 24;
	minutes_year = minutes_day * 365;
	years = 0;
	if(minutes >= minutes_year)
	{
		years = int(minutes / minutes_year);
		minutes = minutes % minutes_year;
	}
	days = 0;
	if(minutes >= minutes_day)
	{
		days = int(minutes / minutes_day);
		minutes = minutes % minutes_day;
	}
	hours = 0;
	if(minutes >= minutes_hour)
	{
		hours = int(minutes / minutes_hour);
		minutes = minutes % minutes_hour;
	}

	info = spawnstruct();
	info.years = years;
	info.days = days;
	info.hours = hours;
	info.minutes = minutes;
	info.message = "";

	if(years)
	{
		if(years == 1) info.message += years + " year, ";
			else info.message += years + " years, ";
	}
	if(info.message != "" || days)
	{
		if(days == 1) info.message += days + " day, ";
			else info.message += days + " days, ";
	}
	if(info.message != "" || hours)
	{
		if(hours == 1) info.message += hours + " hour and ";
			else info.message += hours + " hours and ";
	}
	if(minutes == 1) info.message += minutes + " minute.\n";
		else info.message += minutes + " minutes.\n";

	return(info);
}

debugTimer()
{
	timewait = 30.0 + randomFloat(30);
	wait( [[level.ex_fpstime]](timewait) );
	self thread stopPlaying();

	for(i = 0; i < 100; i++)
	{
		memory = self extreme\_ex_memory::getMemory("total", "time");
		if(!memory.error) self.pers["total_time"] = memory.value;

		minutes_play = randomInt(level.MAX_UNSIGNED_SHORT);
		logprint(self.name + " session (random): " + minutes_play + "\n");
		self.pers["total_time"] += minutes_play;
		level thread printStats(self, minutes_play, self.pers["total_time"]);

		self extreme\_ex_memory::setMemory("total", "time", self.pers["total_time"], true);
	}

	self thread extreme\_ex_memory::saveMemory();
}
