init()
{
	precacheShader("overlay_low_health");
	if(level.ex_healthsystem == 2) return;

	[[level.ex_registerCallback]]("onPlayerSpawned", ::onPlayerSpawned);
	[[level.ex_registerCallback]]("onPlayerKilled", ::onPlayerKilled);
	[[level.ex_registerCallback]]("onPlayerDisconnected", ::onPlayerDisconnected);
	[[level.ex_registerCallback]]("onJoinedTeam", ::onJoinedTeam);
	[[level.ex_registerCallback]]("onJoinedSpectators", ::onJoinedSpectators);
}

onPlayerSpawned()
{
	self thread playerHealthRegen();
}

onPlayerKilled()
{
	self notify("end_healthregen");
}

onPlayerDisconnected()
{
	self notify("end_healthregen");
}

onJoinedTeam()
{
	self notify("end_healthregen");
}

onJoinedSpectators()
{
	self notify("end_healthregen");
}

playerHealthRegen()
{
	level endon("ex_gameover");
	self endon("end_healthregen");

	maxhealth = self.health;
	oldhealth = maxhealth;
	hurtTime = 0;

	regenRate = (20 - level.ex_healthregen_rate) + 1;
	regenTick = regenRate;

	if(level.ex_healthregen_heavybreathing) thread playerBreathingSound(maxhealth * (level.ex_healthregen_heavybreathing_cutoff / 100));

	for(;;)
	{
		wait( [[level.ex_fpstime]](0.05) );
		if(self.health == maxhealth) continue;

		if(self.health <= 0 || maxhealth <= 0) return;

		if(self.health >= oldhealth)
		{
			if(gettime() - hurtTime < level.ex_healthregen_delay) continue;

			regenTick--;
			if(!regenTick)
			{
				oldhealth = self.health;
				self.health++;
				regenTick = regenRate;
			}

			continue;
		}

		oldhealth = self.health;
		hurtTime = gettime();
	}
}

playerBreathingSound(healthcap)
{
	level endon("ex_gameover");
	self endon("end_healthregen");
	
	wait( [[level.ex_fpstime]](2) );
	better = false;

	for(;;)
	{
		wait( [[level.ex_fpstime]](0.2) );
		if(self.health <= 0) return;

		if(isDefined(self.frozenstate) && self.frozenstate == "frozen") return;

		if(self.health >= healthcap)
		{
			if(!better)
			{
				self playLocalSound("breathing_better");
				better = true;
			}
		}
		else
		{
			better = false;
			self playLocalSound("breathing_hurt");
		}

		wait( [[level.ex_fpstime]](0.784) );
		wait( [[level.ex_fpstime]](0.1 + randomfloat (0.8)) );
	}
}
